#ifndef COMMON_H
#define COMMON_H

#include "pcl/point_cloud.h"
#include "pcl/point_types.h"
#include <chrono>

#ifndef SAFE_DELETE
//#   warning "[common.h] SAFE_DELETE already defined..."
#   define SAFE_DELETE(a) {if(a){delete (a);a=nullptr;}}
#endif
#define TIC auto start = std::chrono::system_clock::now();
#define RETIC start = std::chrono::system_clock::now();
#define TOC(title) { std::chrono::duration<double> elapsed_seconds = std::chrono::system_clock::now() - start; \
                     std::cout << title << ": " << elapsed_seconds.count() << " s" << std::endl; }

namespace am
{
    //typedef pcl::PointXYZRGB MyPoint;
    typedef pcl::PointXYZRGBL MyPoint;
    typedef pcl::PointCloud<MyPoint> PCloud;
}

namespace ca
{
    typedef am::MyPoint MyPoint;
    typedef am::PCloud  PCloud;

//    static const Eigen::Vector4f CONTACT_TOUCHING_COLOUR     ( 80.f/255.f, 7.f/255.f, 120.f/255.f, .8f );
//    static const Eigen::Vector4f CONTACT_FIXED_COLOUR        ( 0.f, 40.f/255.f, 255.f/255.f, .8f );
    static const Eigen::Vector4f CONTACT_TOUCHING_COLOUR     ( 10.f/255.f, 204.f/255.f, 10.f /255.f, .9f );
    static const Eigen::Vector4f CONTACT_FIXED_COLOUR        ( 10.f/255.f, 10.f /255.f, 204.f/255.f, .9f );

}

#endif // COMMON_H
