#ifndef __CA_MAPBACK_H__
#define __CA_MAPBACK_H__

#include <Eigen/Dense>

namespace ca
{
    class MapBack
    {
        public:
            typedef float Scalar;

            MapBack();

            static inline int
            project( Eigen::Matrix<Scalar,3,1> &pnt2D
                     , Eigen::Matrix<Scalar,3,1> const& pnt_arg
                     , Eigen::Matrix<Scalar,4,4> const& modelview
                     , Eigen::Matrix<Scalar,4,4> const& projection
                     , Eigen::Matrix<Scalar,4,1> const& viewport   );

            int
            project( Eigen::Matrix<Scalar,3,1> &pnt2D
                     , Eigen::Matrix<Scalar,3,1> const& pnt_arg ) const;

            Eigen::Matrix<Scalar,4,4> const& ModelViewMat   () const { return _modelViewMat;  }
            Eigen::Matrix<Scalar,4,4> const& ProjectionMat  () const { return _projectionMat; }
            Eigen::Matrix<Scalar,4,1> const& ViewportMat    () const { return _viewportMat;   }

        protected:
            Eigen::Matrix<Scalar,4,4> _modelViewMat;
            Eigen::Matrix<Scalar,4,4> _projectionMat;
            Eigen::Matrix<Scalar,4,1> _viewportMat;
    };
}

#endif // __CA_MAPBACK_H__
