#ifndef __CA_ANNOT3DINTERACTORSTYLE_H__
#define __CA_ANNOT3DINTERACTORSTYLE_H__

#include <vtkObjectFactory.h>
#include <vtkSmartPointer.h>
#include <vtkPointPicker.h>
#include <vtkRenderWindow.h>
#include <vtkRenderWindowInteractor.h>
#include <pcl/visualization/pcl_visualizer.h>

namespace ca
{
    class Annot3DInteractorStyle : public pcl::visualization::PCLVisualizerInteractorStyle
    {
        public:
            static Annot3DInteractorStyle* New();

            virtual void OnMouseMove() override
            {
                using pcl::visualization::MouseEvent;

                int x = this->Interactor->GetEventPosition()[0];
                int y = this->Interactor->GetEventPosition()[1];
                MouseEvent event( MouseEvent::MouseMove, MouseEvent::NoButton, x, y, Interactor->GetAltKey (), Interactor->GetControlKey (), Interactor->GetShiftKey (), Superclass::CurrentMode);
                mouse_signal_ (event);

                if ( _propagate_mouse_move )
                    Superclass::OnMouseMove ();
            }

            virtual void Initialize() override
            {
                _propagate_mouse_move = true;
                pcl::visualization::PCLVisualizerInteractorStyle::Initialize();
            }

            virtual void setPropagateMouseMove( bool propagate )
            {
                _propagate_mouse_move = propagate;
            }

        protected:
            bool _propagate_mouse_move;
    };

} // ... ns ca

#endif // __CA_ANNOT3DINTERACTORSTYLE_H__
