#ifndef __CA_DISPLAYEDPRIMITIVE_H__
#define __CA_DISPLAYEDPRIMITIVE_H__

#include <map>
#include <string>

#include "boost/shared_ptr.hpp"
#include "pcl/visualization/pcl_visualizer.h"
#include "primitives/Primitive.h"
#include "primitives/Cuboid.h"

namespace am
{
    //class Primitive;
    //class Cuboid;
    class Plane;
}

namespace ca
{
    class DisplayedPrimitive
    {
        public:
            typedef std::map<std::string,DisplayedPrimitive> Map;

            /// CONSTR
            DisplayedPrimitive()
                : primitive_ptr  (nullptr)
                , hidden         (false)
                , wall           (false)
                , floor          (false)
                , rotation_target(false)
                , tag            ("")
                , shape          ( am::Cuboid::TYPE::CUBOID ){}
            DisplayedPrimitive( am::Cuboid const& cuboid );
            DisplayedPrimitive( am::Plane  const& plane );

            /// METHODS
            std::shared_ptr<am::Cuboid>     CuboidPtr() const;
            std::shared_ptr<am::Plane >     PlanePtr () const;

            int
            reDraw(pcl::visualization::PCLVisualizer::Ptr viewer
                    , std::string                    const name
                    , bool                           const selected
                    , bool                           const colour_code_cuboids = false
                    , bool                           const colour_edges        = false
                    , bool                           const show_ids            = false );
                    //, am::Primitive::Shape           const shape               = am::Primitive::Shape::CUBOID );

            Eigen::Vector4f
            getDrawingColour( bool colour_code_cuboids ) const;

            /// FIELDS
            std::shared_ptr<am::Primitive> primitive_ptr;
            Eigen::Vector4f                colour;
            bool                           hidden;
            bool                           wall;
            bool                           floor;
            bool                           rotation_target;
            std::string                    tag;
            am::Cuboid::TYPE               shape;
    };

} // ... ns ca

#endif // __CA_DISPLAYEDPRIMITIVE_H__
