#ifndef GRABCUTRESULT_H
#define GRABCUTRESULT_H

#include <vector>
#include <opencv2/core/core.hpp>

namespace am
{
    class GrabcutResult
    {
            std::vector<cv::Mat> masks_for_labels_;
            cv::Mat              img_, dep_;

        public:
            void            empty                   ();
            void            add                     ( cv::Mat const& mat );
            void            addForLabel             ( cv::Mat const& mat, unsigned label );
            cv::Mat const&  get_mask_for_label      ( unsigned label ) const;
            int             getBinaryMaskForLabel   ( cv::Mat &masked_depth, unsigned label ) const;

            void            set_image               ( cv::Mat const& img );
            void            set_depth               ( cv::Mat const& dep );
            cv::Mat const&  get_depth               () const;
            cv::Mat const&  get_rgb                 () const;
    }; // ... class GrabcutReult
} // ... ns am

#endif // GRABCUTRESULT_H
