#ifndef PRIMITIVECONTAINER_H
#define PRIMITIVECONTAINER_H

#include <vector>

namespace am
{

    template <typename T>
    class PrimitiveContainer
    {
        public:
            int clear();
            int add  (T const& primitive );
            T      & at        ( int id );
            T const& at        ( int id ) const;
            T      & operator[]( int id );
            T const& operator[]( int id ) const;
            T      & back      ();
            T const& back      () const;

            std::size_t size() const;

            std::vector<T> const&
            Primitives() const;
            std::vector<T> &
            PrimitivesRef();

        protected:
            std::vector<T> _primitives;
    };

} // ns am

#ifndef INC_PRIMITIVECONTAINER_HPP
#   define INC_PRIMITIVECONTAINER_HPP
#   include "PrimitiveContainer.hpp"
#endif

#endif // PRIMITIVECONTAINER_H
