#ifndef PRIMITIVECONTAINTER_HPP
#define PRIMITIVECONTAINTER_HPP

#include "stdlib.h"
#include "PrimitiveContainer.h"

namespace am
{
        template <typename T>
        int
        PrimitiveContainer<T>::clear()
        {
            _primitives.clear();
            return EXIT_SUCCESS;
        }

        template <typename T>
        int
        PrimitiveContainer<T>::add( T const& primitive )
        {
            _primitives.push_back( primitive );
            return EXIT_SUCCESS;
        }

        template <typename T>
        T const&
        PrimitiveContainer<T>::at( int id ) const
        {
            return _primitives[id] ;
        }

        template <typename T>
        T&
        PrimitiveContainer<T>::at( int id )
        {
            return _primitives[id] ;
        }

        template <typename T>
        T const&
        PrimitiveContainer<T>::operator[](int id) const
        {
            return _primitives[id] ;
        }

        template <typename T>
        T &
        PrimitiveContainer<T>::operator[](int id)
        {
            return _primitives[id] ;
        }

        template <typename T>
        T &
        PrimitiveContainer<T>::back()
        {
            return _primitives.back();
        }

        template <typename T>
        T const&
        PrimitiveContainer<T>::back() const
        {
            return _primitives.back();
        }

        template <typename T>
        std::vector<T> const&
        PrimitiveContainer<T>::Primitives() const
        {
            return _primitives;
        }
        template <typename T>
        std::vector<T> &
        PrimitiveContainer<T>::PrimitivesRef()
        {
            return _primitives;
        }

        template <typename T>
        std::size_t
        PrimitiveContainer<T>::size() const
        {
            return _primitives.size();
        }
} // ns am

#endif // PRIMITIVECONTAINTER_HPP
