#ifndef ROTATORTHREAD_H
#define ROTATORTHREAD_H

#include "QtGuiUpdaterThread.h"
#include <Eigen/Dense>
#include <memory>

namespace am
{
    class AnnotationController;
}

class RotatorThread : public QtGuiUpdaterThread
{
    public:
        RotatorThread( std::shared_ptr<am::AnnotationController> controller );

        std::pair<int,std::string>
        prepare(float to_deg = 360.f, float from_deg = 0.f, float step = 1.f , Eigen::Vector3f *centroid = nullptr, Eigen::Vector3f *rot_axis = nullptr );

        void one_loop() override;

        void setDoneFrameId( int );

    protected:
        std::shared_ptr<am::AnnotationController> _controller;
        bool                                      _prepared;
        Eigen::Vector3f                           _rot_axis, _centroid;
        float                                     _degrees, _stop_degrees, _step;
        int _doneframeid, _myframeid;
};

#endif // ROTATORTHREAD_H
