#include <memory>
#include <iostream>

#include <pcl/io/openni_grabber.h>
#include <pcl/io/oni_grabber.h>
#include <pcl/io/pcd_io.h>
#include <pcl/point_cloud.h>
#include <pcl/visualization/cloud_viewer.h>
#include "pcl/common/pca.h"
//#include "pcl/surface/concave_hull.h"
#include <pcl/filters/voxel_grid.h>
#include <pcl/console/parse.h>

#include <opencv2/highgui/highgui.hpp>

#include <QApplication>
#include "ui/QtCloudViewer.h"

#include "cuboid_approx/util/AMUtil2.h"
#include "cuboid_approx/util/MyIntrinsics.h"

#ifdef CA_WITH_BFCUDA
    #include "BilateralFilterCuda.hpp"
#endif

//#include "GrabCutTest.h"
//#include "GrabCutTestMultiLabel.h"
//#include "DepthProcessor.h"

//#include "Cuboid.h"

//#include "common.h"

//  ./rgbd-viewer --savepcd --prefix /home/bontius/workspace/SmartGeometry/cuboidTest1/data/grab1
// /home/bontius/workspace/progs/rgbdemo/build/bin/rgbd-viewer --prefix /home/bontius/workspace/SmartGeometry/cuboidTest1/data/grab2

#include "../src/primitives/under_dev.cpp"
namespace am
{
    int testing();
#if 0
    template <typename PointT>
    extern int clusterNYU( boost::shared_ptr<pcl::PointCloud<PointT> > cloud_arg
                           , pcl::PointIndices::Ptr                    indices_arg
                           , int   const K             = 15
                           , float const radius        = -1.f
                           , float const filter_nmeans = 50
                           , int   const filter_stddev = .1
                           , float const density_cap_median_multiplier = 1.5f
                           , bool  const debug         = false );
#endif
}

#include "cuboid_approx/common.h"
#include "proc3d/MyVoxelGrid.h"
#include "primitives/Cuboids.h"
#include "cuboid_approx/primitives/Contact.h"

#include "cuboid_approx/proc3d/CloudColouring.h" // remove after testing

int main( int argc, char **argv )
{
//    if ( argc == 4 )
//        for ( float val = atof(argv[1]); val < atof(argv[2]); val += atof(argv[3]) )
//        {
//            std::cout << "val: " << val << ", colour: " << ca::CloudColouring::getColourForDistance( val, 1.f, 0.f ).transpose() << std::endl;
//        }
//    return 0;

    //return testBoxes();
    //return am::testing();
    //return main2();

    /**/ if ( /**/ pcl::console::find_switch( argc, argv, "--compare_boxes") )
    {
        if ( argc < 5 ) { std::cerr << "[" << __func__ << "]: " << "usage:\t --compare_boxes initial_cuboids.dat optim_cuboids.dat gt_cuboids.box\n" << std::endl; return EXIT_FAILURE; }
#if 0
        std::map<std::string,am::Cuboids> cuboids_map;

        // read paths
        std::map<std::string,std::string> paths;
        {
            paths[ "init" ] = argv[2];
            paths[ "opt" ]  = argv[3];
            paths[ "gt" ]   = argv[4];
            for ( auto it = paths.begin(); it != paths.end(); ++it )
                std::cout << it->first << ": " << it->second << "\n";
        }

        int max_length = 0;
        std::map< std::string, std::vector<double> > lengths;
        for ( auto it = paths.begin(); it != paths.end(); ++it )
        {
            // allocate with insert
            lengths[it->first] = std::vector<double>();
            cuboids_map[ it->first ] = am::Cuboids();

            // load
            am::Cuboids::readFromFile( cuboids_map[ it->first ], it->second, /* inliers_path: */ nullptr, /* cloud: */ nullptr, /* indices: */ nullptr );
            // read sides
            for ( int cid = 0; cid != cuboids.size(); ++cid )
            {
                auto tmp = cuboids.at(cid).getSideLengths();
                lengths[it->first].insert( lengths[it->first].end(), tmp.begin(), tmp.end() );

                // track longest
                if ( lengths[it->first].size() > max_length ) max_length = lengths[it->first].size();
            }
        }

        // print labels
        {
            std::cout << "lengths:";
            for ( auto it = lengths.begin(); it != lengths.end(); ++it )
                std::cout << "\t" << it->first;
            std::cout << "\n";
        }

        // print lengths
        for ( size_t i = 0; i != max_length; ++i )
        {
            for ( auto it = lengths.begin(); it != lengths.end(); ++it )
            {
                std::cout << "\t";
                if ( i < it->second.size() )    std::cout << it->second.at(i);
                else                            std::cout << "-";
            }
            std::cout << "\n";
        }
#endif
        return EXIT_SUCCESS;
    }
    else if ( /**/ pcl::console::find_switch( argc, argv, "--insert_box")
              ||   pcl::console::find_switch( argc, argv, "--insert-box") )
    {
        ///
        /// \brief insert-box Inserts a box id into a graph by shifting everything above it one up
        ///

        std::string graph_path;
        pcl::console::parse_argument( argc, argv, "--insert_box", graph_path );

        int to_id;
        int id_place = std::max( pcl::console::find_argument(argc, argv, "--insert_box"),
                                 pcl::console::find_argument(argc, argv, "--insert-box")  ) + 2;
        if ( (id_place < 0) || (id_place > argc-1) || graph_path.empty() )
        {
            std::cerr << "[" << __func__ << "]: " << "usage:\n\t--insert_box path to_id\n";
            return EXIT_FAILURE;
        }
        to_id = atoi( argv[id_place] );

        int err = EXIT_SUCCESS;
        std::cout << "insert_box to " << graph_path << " at " << to_id << ", so everything from " << to_id << " shifts up" << std::endl;

        std::vector<am::Contact> contacts;
        err = am::Contact::read( contacts, graph_path, NULL );

        // work
        {
            for ( size_t contact_id = 0; contact_id != contacts.size(); ++contact_id )
            {
                for ( int i = 0; i != contacts[contact_id].ids.size(); ++i )
                {
                    if ( contacts[contact_id].ids[i] >= to_id )
                    {
                        ++contacts[contact_id].ids[i];
                        std::cout << "shifting " << contacts[contact_id].ids[i]-1 << " to " << contacts[contact_id].ids[i] << std::endl;
                    }
                }
            }
        }

        // write contacts
        if ( (EXIT_SUCCESS == err) && contacts.size() )
        {
            std::string command = "cp " + graph_path + " " + graph_path + ".bak";
            int err = system( command.c_str() );
            if ( err != EXIT_SUCCESS )
            {
                std::cerr << "[" << __func__ << "]: " << "\"system(" << command << "\") failed with code " << err << std::endl;
            }

            // write contacts
            if ( EXIT_SUCCESS == err )
            {
                err = am::Contact::write( contacts, graph_path );

                if ( EXIT_SUCCESS == err )
                    std::cout << "[" << __func__ << "]: " << "contacts written to " << graph_path << std::endl;
                else
                    std::cout << "[" << __func__ << "]: " << "contacts NOT written to " << graph_path << std::endl;
            }
        }

        return err;
    }
    else if ( /**/ pcl::console::find_switch( argc, argv, "--move_box")
              ||   pcl::console::find_switch( argc, argv, "--move-box")
             )
    {
        enum MODE { MOVE, INSERT } mode = MOVE;
        if ( pcl::console::find_switch( argc, argv, "--insert_box")
             || pcl::console::find_switch( argc, argv, "--insert-box") )
            mode = INSERT;

        if ( argc < 5 ) { std::cerr << "[" << __func__ << "]: " << "usage:\t --move_box p0 p1 initial_cuboids.dat [graph.txt] moves box#p0 to position #p1 in both files\n" << std::endl; return EXIT_FAILURE; }

        int         from = atoi( argv[2] );
        int         to   = atoi( argv[3] );

        std::string path = argv[4], graph_path;
        if ( argc > 5 )
            graph_path = argv[ 5 ];

        am::Cuboids cuboids;
        am::Cuboids::readFromFile( cuboids, path, NULL, NULL, NULL );
        if ( to == -1 ) to = cuboids.size()-1;

        std::vector<am::Contact> contacts;
        if ( !graph_path.empty() )
        {
            int max_id = 0;
            am::Contact::read( contacts, graph_path, &max_id );

            if ( max_id >= cuboids.size() )
            {
                std::cerr << "cuboids.size: " << cuboids.size() << ", max proxy id in graph: " << max_id << "...exiting..." << std::endl;
                return EXIT_FAILURE;
            }
        }

        if ( (from < 0) || (to < 0) || (from >= cuboids.size()) || (to >= cuboids.size()) )
        {
            std::cerr << "[" << __func__ << "]: " << "from or to not within limits...exiting: " << from << " -> " << to << std::endl;
            return EXIT_FAILURE;
        }

        // debug
        {
            std::cout << "moving cuboid #" << from << " to cuboid #" << to << " in " << path;
            if ( !graph_path.empty() ) std::cout << " and " << graph_path;
            std::cout << endl;
        }

        // WORK
        {
            if ( mode == MOVE )
            // swap cuboids
            {
                am::Cuboid tmp;
                cuboids.at(from).cloneTo( tmp               );
                cuboids.at(to  ).cloneTo( cuboids.at(from)  );
                tmp             .cloneTo( cuboids.at(to)    );

                // swap contacts
                for ( size_t cid = 0; cid != contacts.size(); ++cid )
                {
                    for ( size_t i = 0; i != contacts[cid].ids.size(); ++i )
                    {
                        if      ( contacts[cid].ids[i] == from ) contacts[cid].ids[i] = to;
                        else if ( contacts[cid].ids[i] == to   ) contacts[cid].ids[i] = from;
                    }
                }
            }
            else if ( mode == INSERT )
            {
                am::Cuboids cpy;
                for ( int i = 0; i != cuboids.size(); ++i )
                {
                    if ( i == to )
                        cpy.add( cuboids.at(from) );
                    if ( i != from )
                        cpy.add( cuboids.at(i) );
                }
                cuboids = cpy;

                // swap contacts
                for ( size_t cid = 0; cid != contacts.size(); ++cid )
                {
                    for ( size_t i = 0; i != contacts[cid].ids.size(); ++i )
                    {
                        if      ( contacts[cid].ids[i] == from ) contacts[cid].ids[i] = to;
                        else if ( (contacts[cid].ids[i] >= to) && (contacts[cid].ids[i] < from) ) ++contacts[cid].ids[i];
                    }
                }
            }
            else
            {
                std::cerr << "[" << __func__ << "]: " << "unknown mode...exiting" << std::endl;
                return 0;
           }
        }

        int err = 0;
        // write cuboids
        {
            // backup cuboid file
            {
                std::string command = "cp " + path + " " + path + ".bak";
                int err = system( command.c_str() );
                if ( err != EXIT_SUCCESS ) { std::cerr << "[" << __func__ << "]: " << "\"system(" << command << "\") failed with code " << err << std::endl; }
            }

            err += am::Cuboids::writeToFile( cuboids, path, 0, 0 );
        }

        // write contacts
        if ( contacts.size() )
        {
            // backup graph file
            if ( !graph_path.empty() )
            {
                std::string command = "cp " + graph_path + " " + graph_path + ".bak";
                int err = system( command.c_str() );
                if ( err != EXIT_SUCCESS ) { std::cerr << "[" << __func__ << "]: " << "\"system(" << command << "\") failed with code " << err << std::endl; }
            }

            // write contacts
            err += am::Contact::write( contacts, graph_path );
        }

        return err;
    }
    else if ( /**/ pcl::console::find_switch( argc, argv, "--copy_box")
              ||   pcl::console::find_switch( argc, argv, "--copy-box") )
    {
        // --copy-box view1_opti.dat chairs_view_1_ground.box 34

        std::string cuboids_path_from, cuboids_path_to;
        int err = EXIT_SUCCESS;

        // parse
        int copy_box_arg_id = std::max( pcl::console::parse_argument(argc, argv, "--copy_box", cuboids_path_from),
                                        pcl::console::parse_argument(argc, argv, "--copy-box", cuboids_path_from)  );
        if ( copy_box_arg_id+3 >= argc )
        {
            std::cerr << "usage:\n\t --copy_box from_path to_path cuboid_id\n";
            return EXIT_FAILURE;
        }
        std::cout << "parsing cuboids_path_to: " << argv[ copy_box_arg_id+2 ] << ", cuboid_id: " << argv[ copy_box_arg_id+3 ] << std::endl;
        cuboids_path_to = std::string( argv[ copy_box_arg_id+2 ] );
        int cuboid_id = atoi( argv[ copy_box_arg_id+3 ] );

        // read
        am::Cuboids cuboids_from;
        err = am::Cuboids::readFromFile( cuboids_from, cuboids_path_from, NULL, NULL, NULL );
        if ( (err != EXIT_SUCCESS) || (cuboid_id >= cuboids_from.size()) )
        {
            std::cerr << "usage:\n\t --copy_box from_path to_path cuboid_id (cuboid_id " << cuboid_id << " >= " << cuboids_from.size() << " cuboids_from.size()), err: " << (int)err << "\n";
            return EXIT_FAILURE;
        }

        // read
        am::Cuboids cuboids_to;
        err = am::Cuboids::readFromFile( cuboids_to, cuboids_path_to, NULL, NULL, NULL );
        if ( err != EXIT_SUCCESS )
        {
            std::cerr << "[" << __func__ << "]: " << "readFromFile " << cuboids_path_to << " failed" << std::endl;
            return err;
        }

        // append
        err = cuboids_to.add( cuboids_from.at(cuboid_id) );
        if ( err != EXIT_SUCCESS )
        {
            std::cerr << "[" << __func__ << "]: " << "cuboids_to.add failed" << std::endl;
            return err;
        }

        // write
        std::string out_path = boost::filesystem::change_extension( cuboids_path_to, ".dat" ).string();
        err = am::Cuboids::writeToFile( cuboids_to, out_path, 0, 0 );
        if ( err != EXIT_SUCCESS )
        {
            std::cerr << "[" << __func__ << "]: " << "cuboids_to.writeToFile to " << out_path << " failed" << std::endl;
            return err;
        }

        return err;
    }
    else if ( /**/ pcl::console::find_switch( argc, argv, "--save_contacts") )
    {
        std::string path;
        if ( (argc < 3) || (pcl::console::parse_argument(argc,argv,"--save_contacts",path) < 0) )
        {
            std::cerr << "[" << __func__ << "]: " << "usage:\t --save_contacts cuboids.dat/box [--size_increment 0.005]\n" << std::endl;
            return EXIT_FAILURE;
        }

        // offset
        float offset = am::AnnotationController::INTERSECT_OFFSET;
        pcl::console::parse_argument( argc, argv, "--size_increment", offset );

        // ouput
        boost::filesystem::path boost_path( path );
        std::string out_path = (boost_path.parent_path() / boost_path.stem()).string() + "_graph.txt";

        // debug
        std::cout << "saving intersections of " << path << "to " << out_path << std::endl;

        am::Cuboids cuboids;
        am::Cuboids::readFromFile( cuboids, path, NULL, NULL, NULL );

        std::vector<am::Contact> contacts;
        for ( int i = 0; i != cuboids.size()-1; ++i )
        {
            for ( int j = i+1; j != cuboids.size(); ++j )
            {
                if ( am::Cuboid::intersect(cuboids.at(i), cuboids.at(j), offset) )
                {
                    contacts.push_back( am::Contact( (std::vector<int>){i, j}, am::Contact::TOUCHING) );
                }
            }
        }

        return am::Contact::write( contacts, out_path );
    }
    else if ( /**/ pcl::console::find_switch( argc, argv, "--sort_contacts") )
    {
        std::string path;
        if ( (argc < 3) || (pcl::console::parse_argument(argc,argv,"--sort_contacts",path) < 0) )
        {
            std::cerr << "[" << __func__ << "]: " << "usage:\t --sort_contacts graph.txt\n" << std::endl;
            return EXIT_FAILURE;
        }

        std::vector<am::Contact> contacts;
        am::Contact::read( contacts, path );
        for ( int i = 0; i != contacts.size(); ++i )
            std::sort( contacts[i].ids.begin(), contacts[i].ids.end() );
        std::sort( contacts.begin(), contacts.end() );

        std::string bkp_path = path + ".orig";
        if ( !boost::filesystem::exists(bkp_path) )
        {
            boost::filesystem::copy( path, bkp_path );
            std::cout << "original backed up to " << bkp_path << "\n";
        }
        std::cout << "sorted saved to " << path << std::endl;
        am::Contact::write( contacts, path );
        boost::filesystem::copy( path, bkp_path + ".sorted" );
        return 0;
    }
    else if ( /**/ pcl::console::find_switch( argc, argv, "--compare_contacts") )
    {
        // ./cuboidTest1 --compare_contacts /media/Data2/workspace_store/Data/nyu_labeled/converted/1449_graph.txt /media/Data2/workspace_store/Data/nyu_labeled/converted/support/001449_gt_graph.txt
        // /home/bontius/cuboidTest1/build/cuboidTest1 --compare_contacts view1_init_graph.txt view1_GT_graph.txt 33 --verbose --map init_to_gt.map
        int req_args = 4;

        int switch_id = std::max( pcl::console::find_switch(argc,argv,"--compare_contacts"), pcl::console::find_switch(argc,argv,"--compare-contacts") );
        bool verbose = pcl::console::find_switch(argc,argv,"--verbose") || pcl::console::find_switch(argc,argv,"-v");
        if ( verbose ) ++req_args;

        int max_allowed_cuboid_id = std::numeric_limits<int>::max();
        if ( pcl::console::parse_argument( argc, argv, "--max-id", max_allowed_cuboid_id ) > 0 )
           ++req_args;

        std::string map_path;
        if ( pcl::console::parse_argument( argc, argv, "--map", map_path ) > 0 )
            ++req_args;

        if ( argc < req_args || pcl::console::find_switch(argc,argv,"--help") || pcl::console::find_switch(argc,argv,"-h") )
        {
            std::cerr << "[" << __func__ << "] " << "usage:\n\tcuboidTest --compare_contacts [init_]graph.txt gt_graph.txt [opti_graph.txt] [--verbose=false] [--map map_path]\n"
                         << "\toutput: precision recall\n";

            return EXIT_FAILURE;
        }


        float init_prec, init_rec, opti_prec, opti_rec;
        int max_gt_box_id = 0, gt_contact_count = 0;
        int err = am::Contact::compareFiles( std::string(argv[switch_id+1]), std::string(argv[switch_id+2]), verbose, &init_prec, &init_rec, &max_allowed_cuboid_id, (map_path.empty() ? NULL : &map_path), &gt_contact_count, &max_gt_box_id );
        if ( (argc > switch_id + 3) && (std::string(argv[switch_id+3])[0] != '-') )
        {
            err = am::Contact::compareFiles( std::string(argv[switch_id+3]), std::string(argv[switch_id+2]), verbose, &opti_prec, &opti_rec, &max_allowed_cuboid_id, (map_path.empty() ? NULL : &map_path) );
        }

        if ( pcl::console::find_switch(argc,argv,"--json") )
        {
            // /home/bontius/cuboidTest1/build/cuboidTest1 --compare_contacts init_graph.txt GT_graph.txt opti_graph.txt --json

            std::string name = boost::filesystem::path(argv[switch_id+1]).parent_path().string();
            if ( name.empty() )
            {
                name = boost::filesystem::current_path().stem().string();
            }
            std::cout << "\n,\"\": {\n"
                      << "\t\"img\": \"" << name <<"\",\n"
                      << "\t\"prec_init\": \"" << init_prec * 100.f << "\",\n"
                      << "\t\"recall_init\": \"" << init_rec * 100.f<< "\",\n"
                      << "\t\"prec_opti\": \"" << opti_prec * 100.f<< "\",\n"
                      << "\t\"recall_opti\": \"" << opti_rec * 100.f<< "\",\n"
                      << "\t\"GT_graph\": \"true\",\n"
                      << "\t\"GT_sides\": \"false\",\n"
                      << "\t\"sides_prec_init\": \"0\",\n"
                      << "\t\"sides_prec_opti\": \"0\",\n"
                      << "\t\"cuboid_count\": \"" << max_gt_box_id << "\",\n"
                      << "\t\"contact_count\": \"" << gt_contact_count << "\",\n"
                      << "\t\"group\": \"own\"\n"
                      << "}\n\n";
            if ( boost::filesystem::exists("optimized_front.png") )
            {
                int err;
                err = system( ("cp optimized_front.png /home/bontius/workspace/SmartGeometry/cuboidTest1/results/public_html/img/" + name + ".png").c_str() );
                if ( err ) std::cout << "[" << __func__ << "]: " << "system returned " << err << std::endl;
            }
            else
                std::cout << "cannot copy optimized_front.png, does not exist" << std::endl;

        }
        if ( pcl::console::find_switch(argc,argv,"--ncontacts") )
        {
            std::cout << "\t" << gt_contact_count;
        }

        std::cout << std::endl;

        return err;
    }
    else if ( /**/ pcl::console::find_switch( argc, argv, "--record_nyu"   ) )
    {
        // 0,0,1, 0,-0.1,-1, 0,1,0,


    }
    else if ( (argc > 1) && (std::string(argv[1]).find("pcd") != std::string::npos) )
    {
        pcl::PointCloud<am::MyPoint>::Ptr cloud( new pcl::PointCloud<am::MyPoint>() );
        pcl::io::loadPCDFile( std::string(argv[1]), *cloud );

        pcl::PointIndices::Ptr indices( new pcl::PointIndices() );
        for ( int i = 0; i < cloud->size(); ++i )
            indices->indices.push_back( i );

        am::Cuboid cuboid;
        return am::Cuboid::fromCloudWithPCA<am::MyPoint>( /*                  cuboid_out: */ cuboid
                                                          , /*                     cloud: */ cloud
                                                          , /*                   indices: */ indices
                                                          , /*         max_neighbours(K): */ (argc > 2) ? atoi(argv[2]) : 20
                                                          , /*                    radius: */ -1.f
                                                          , /*             clean_n_means: */ 50
                                                          , /*              clean_stddev: */ .1
                                                          , /* density_median_multiplier: */ 1.5f
                                                          , /*                     debug: */ true
                                                        );
    }

    // http://www.pcl-users.org/Defining-new-SACModel-td2645441.html
    // ---- PCD --------------------------------------------
    else if (    (argc > 2)
              && (std::string(argv[1]).find("convert_raw") != std::string::npos) )
    {
        // rawtest /media/Data2/workspace_store/Data/nyu_labeled/depth_1449.raw /media/Data2/workspace_store/Data/nyu_labeled/image_1449.png
        cv::Mat dep;
        std::string deppath(argv[2]);
        am::util::cv::loadDepthAsBinary<ushort,float>( dep, deppath, 1000.f );
        {
            double minVal, maxVal;
            cv::minMaxLoc( dep, &minVal, &maxVal );
            std::cout << "minmaxdepth: " << minVal << " , " << maxVal << std::endl;
        }
        cv::imshow( "dep", dep / 8000. * 32768. );
    }
    if (    (argc > 2)
         && (std::string(argv[1]).find("rawtest") != std::string::npos) )
    {
        // --rawtest /home/bontius/workspace/SmartGeometry/cuboidTest1/data/grab2/A00363912484102A/view-00005982/raw/depth16bits.raw /home/bontius/workspace/SmartGeometry/cuboidTest1/data/grab2/A00363912484102A/view-00005982/raw/color.bmp

        cv::Mat dep;
        std::string deppath(argv[2]);
        am::util::cv::loadDepthAsBinary<ushort,float>( dep, deppath, 1000.f );
        {
            double minVal, maxVal;
            cv::minMaxLoc( dep, &minVal, &maxVal );
            std::cout << "minmaxdepth: " << minVal << " , " << maxVal << std::endl;
        }
        cv::imshow( "dep", dep / 8000. * 32768. );

        std::string rgb_path(argv[3]);
        cv::Mat rgb = cv::imread( rgb_path, cv::IMREAD_UNCHANGED );
        cv::imshow( "img", rgb );

#if CA_WITH_BFCUDA
        // debug crossbil
        {
            cv::Mat dep2;
            BilateralFilterCuda<float> bfc;
            bfc.runBilateralFiltering( dep, rgb, dep2 );
                                                                //float gaussian_delta, float eucledian_delta, int filter_radius,
                                                                //float max )
            cv::imshow( "dep2", dep2 / 8000. * 32768. );
        }
#endif

        cv::waitKey();

        return EXIT_SUCCESS;
    }
    else if (    (argc > 3)
         && (std::string(argv[1]).find("pgm2dat") != std::string::npos) )
    {
        // --pgm2dat /media/Data1/workspace/SmartGeometry/Data/data2/dep16_20131129_100705_343.pgm /media/Data1/workspace/SmartGeometry/Data/data2/dep16_20131129_100705_343.dat
        // --pgm2dat /home/bontius/workspace/SmartGeometry/cuboidTest1/data/out0/dep16_20131129_100705_343.pgm /home/bontius/workspace/SmartGeometry/cuboidTest1/data/out0/dep16_20131129_100705_343.pgm

        am::util::cv::saveDepthAsBinary<ushort,float>( std::string(argv[2]), std::string(argv[3]), 8. / 32767. );
        // test
        cv::Mat dep;
        am::util::cv::loadDepthAsBinary<ushort,float>( dep, std::string(argv[3]), 32767. / 8.  );
        cv:: imshow( "dep", dep  );
        cv::waitKey();

        return EXIT_SUCCESS;
    }
    else if (    (argc > 1)
         && (std::string(argv[1]).find("pcd")     != std::string::npos) )
    {
        // /home/bontius/workspace/SmartGeometry/cuboidTest1/build/cuboid01.pcd
        using namespace am;

        std::string cloud_path = argv[1];

        // read
        am::PCloud::Ptr        cloud_ptr    ( new am::PCloud() );
        {
            pcl::io::loadPCDFile( cloud_path, *cloud_ptr );
        }
        am::PCloud::Ptr        floor_cloud_ptr( new am::PCloud() ) ;
        {
            pcl::io::loadPCDFile( "/home/bontius/workspace/SmartGeometry/cuboidTest1/build/plane00.pcd", *floor_cloud_ptr );
        }

        // select all indices
        pcl::PointIndices::Ptr indices_ptr( am::util::pcl::allIndicesOf(cloud_ptr) );
        //pcl::PointIndices::Ptr floor_indices_ptr( am::util::pcl::allIndicesOf(floor_cloud_ptr) );

        // create cluster frame using up vector
        pcl::ModelCoefficients::Ptr floor_coeffs( new pcl::ModelCoefficients() );
        Eigen::Vector4f floor_coeffs_eigen;
        {
            //floor_coeffs_eigen = {-0.135464, 0.911203, 0.389047, -1.51217}; // floor_cuboid_ptr->Planes()[0].CoeffsPtr()
            //floor_coeffs_eigen = {-0.019662, 0.919685, 0.392164, -0.962307}; // common2
            //floor_coeffs_eigen = {-0.018087, 0.946838, 0.321201, -1.270532};
            //floor_coeffs_eigen = { 0.032372, 0.994128, 0.103254, -0.661859 };
             floor_coeffs_eigen = {  -0.021091, 0.949342, 0.313536, -1.259271  }; //  -0.021091, 0.949342, 0.313536, -1.259271
            //floor_coeffs_eigen = { 0.075800, 0.970901, 0.227170, -0.860530 };   // squared_cluster00.pcd
            // Plane-0.019662 0.919685 0.392164 -0.962307
            // -0.018087, 0.946838, 0.321201, -1.270532

            // /home/bontius/workspace/SmartGeometry/cuboidTest1/build/cluster00.pcd
            std::cout << "showing cluster with " << indices_ptr->indices.size() << std::endl;

            floor_coeffs->values.resize(4);
            std::copy( floor_coeffs_eigen.data(), floor_coeffs_eigen.data()+4, floor_coeffs->values.begin() ); // = *(floor_coeffs_eigen.data());
            std::cout << "floor_coeffs: " << *floor_coeffs << std::endl;
        }

        // subfigure1: pointcloud + floor box
        {
            am::CloudViewer v;
            v.ViewerPtr()->setBackgroundColor( 1., 1.f, 1.f );
            //v.addPointCloud( floor_cloud_ptr, "floor" );
            v.addPointCloud( cloud_ptr );
            am::Cuboids cuboids;
            am::Cuboids::readFromFile( cuboids, "/home/bontius/workspace/SmartGeometry/cuboidTest1/build/figure_autocluster/double_sofa/floor_cuboid/cuboids.dat" );
            //am::Cuboid::from_cloud( floor_cuboid, floor_cloud_ptr, am::util::pcl::allIndicesOf(floor_cloud_ptr) );
            //cuboids[0].resizeAlongFrame( {1.f, 0.f, 0.f} );
            cuboids[0].draw4( v.ViewerPtr(), "floor_cuboid" );

            std::vector<Eigen::Vector3f> pos_focal_up = {  {	1.23439f, -1.39432f, -1.37946f }
                                                          ,{ -0.127083f, 0.305916f, -0.067527f}
                                                          ,{ -0.377182f, 0.357282f, -0.854449f } };
            am::util::pcl::setCameraPosFocalUp( v.ViewerPtr(), pos_focal_up );

            v.ViewerPtr()->spin();
            //return 0;
        }

        Eigen::Matrix4f frame;
        DepthProcessor::PCA_withPlane( frame
                                       , floor_coeffs_eigen
                                       , cloud_ptr
                                       , indices_ptr );
        //return EXIT_SUCCESS;
#if 1 // recomment after pca is fixed

        am::Cuboids cuboids;
        {
            //boost::io::
            // TODO: slabs should pass over included points to the cuboids!

            MyVoxelGrid::segment( /*                      out_cuboids: */ cuboids
                                  , /*                       in_cloud: */ cloud_ptr
                                  , /*                    local_frame: */ frame
                                  , /*                    indices_ptr: */ nullptr
                                  , /*           voxelgrid_resolution: */ .125f
                                  , /* slab_size_threshold_percentage: */ .005f
                                  , /*                 max_slab_count: */ 30
                                  , true );
        }
        boost::filesystem::path cloud_path_boost( cloud_path );
        std::string output_path = (cloud_path_boost.parent_path() / cloud_path_boost.stem()).string() + "_auto_cuboids.dat";

        am::Cuboids::writeToFile( cuboids
                                  , output_path
                                  , -1
                                  , -1 );
        std::cout << "wrote to " << output_path << std::endl;

#endif
#if 0
        // work
        {
            // params
            const float resolution = .15f;

            // CONSTs/
            const auto colours = am::util::nColoursEigen( 25, 1. );

            // LOCAL
            PCloud::Ptr local_cloud_ptr;
            {
                am::DepthProcessor::cloud2Local( local_cloud_ptr
                                                 , frame
                                                 , cloud_ptr
                                                 );
            }

            // show
            auto vptr = am::CloudViewer::showCloud( local_cloud_ptr, "localcloud", nullptr, 2., false );

            // strip
            auto xyzrgb_cloud_ptr = am::util::pcl::toXYZRGBCloud<am::PCloud::Ptr>( local_cloud_ptr );

            // indicesshowCloud( local_cloud_ptr, "localcloud", nullptr, 2., false );

            pcl::PointIndices::Ptr remainder_indices_ptr( am::util::pcl::allIndicesOf(xyzrgb_cloud_ptr) );

            // Create the filtering object
            pcl::VoxelGrid<pcl::PointXYZRGB> sor;
            std::vector<int>                 leafs;
            {
                pcl::PointCloud<pcl::PointXYZRGB>::Ptr cloud_filtered_ptr( new pcl::PointCloud<pcl::PointXYZRGB> );
                sor.setIndices       ( remainder_indices_ptr );
                sor.setSaveLeafLayout( true                  );
                sor.setInputCloud    ( xyzrgb_cloud_ptr      );
                sor.setLeafSize      ( resolution, resolution, resolution );
                sor.filter           ( *cloud_filtered_ptr   );

                // store leafs if first grid
                leafs = sor.getLeafLayout();
            }
            //MyVoxelGrid::drawGrid<pcl::PointXYZRGB>( vptr->VP()
            //                                         , leafs
            //                                         , &sor );

            int slab_id    = 0;
            int diff_count = 0;
            do
            {
                // pointcount in leafs
                std::vector<int> points_in_voxels; // size: d1 * d2 * d3
                {
                    MyVoxelGrid::countPointsInVoxels<pcl::PointXYZRGB>( points_in_voxels
                                                           , xyzrgb_cloud_ptr
                                                           , remainder_indices_ptr
                                                           , leafs
                                                           , &sor
                                                           , vptr->VP() );
                }

                std::vector<int> points_in_planes; // size: d1 + d2 + d3
                {
                    countPointsInPlanes( points_in_planes
                                         , points_in_voxels
                                         , &sor );
                }

                // select max dims
                MaxPlanes max_planes;
                {
                    selectMaxPlanes( max_planes
                                     , points_in_planes
                                     , &sor );
                }

                // debug
                {
                    am::util::printVector( points_in_planes, "pointcounts" );

                    std::cout << "maxdim: "          << max_planes.max_dim_id
                              << " with "            << max_planes.max_point_count[ max_planes.max_dim_id ]
                              << " points at coord " << max_planes.getMaxDimCoord()
                              << std::endl;
                }


                // select min max in this plane
                std::vector<Eigen::MatrixX2i> slabs;
                {
                    Eigen::MatrixX2i limits( 3, 2 );
                    limits << max_planes.getMaxDimCoord(), max_planes.getMaxDimCoord(),
                              0, sor.getNrDivisions()(max_planes.dim1_id)-1, // inclusive!
                              0, sor.getNrDivisions()(max_planes.dim2_id)-1; // inclusive!
                    slabFromPlaneRec( slabs
                                      , limits
                                      , max_planes
                                      , leafs
                                      , &sor
                                      /* debug: */ , vptr->VP() );
                    for ( int i = 0; i < slabs.size(); ++i )
                        std::cout << "slabs[" << i << "]:\n" << slabs[i] << std::endl;
                }

                // split slab?
                if ( 1 )
                {
                    std::vector<Eigen::MatrixX2i> tmp_slabs;
                    MyVoxelGrid::splitSlabs( tmp_slabs
                                            , slabs
                                            , .1f
                                            , leafs
                                            , points_in_voxels
                                            , max_planes
                                            , &sor );
                    slabs = tmp_slabs;
                }

                // remove slab
                {
                    for ( auto const& slab : slabs )
                    {
                        pcl::PointIndices::Ptr tmp_indices_ptr;
                        removeSlabFromCloud<pcl::PointXYZRGB>( tmp_indices_ptr
                                                               , leafs
                                                               , xyzrgb_cloud_ptr
                                                               , remainder_indices_ptr
                                                               , max_planes
                                                               , slab // minmax
                                , &sor                  );
                        //am::CloudViewer::showCloud( xyzrgb_cloud_p0.00720685  0.393566 -0.919268tr, "removed", tmp_indices_ptr, false );

                        diff_count = remainder_indices_ptr->indices.size() - tmp_indices_ptr->indices.size();
                        std::cout << "SLAB size: " << diff_count << std::endl;
                        remainder_indices_ptr = tmp_indices_ptr;
                    }
                }

                //if ( slab_id == 4 )
                for ( int l_slab_id = 0; l_slab_id < slabs.size(); ++l_slab_id )
                {
                    char slab_name[255];
                    sprintf( slab_name, "slab%d", slab_id );
                    MyVoxelGrid::drawSlab( vptr->VP(), slabs[l_slab_id] /*minmax*/, max_planes, &sor, slab_name, colours[slab_id] );
                    ++slab_id;
                }
                vptr->VP()->spin();

                // am::CloudViewer::showCloud( cloud_filtered_ptr, "voxelized", nullptr, 5., true );
            } while ( (slab_id < 25) && (diff_count > 10) );

            vptr->VP()->spin();
        } // work
#endif

        return 0;
#if 0
        const double distanceThreshold = .02;

        if ( (std::string(argv[1]).find("plane") != std::string::npos)
            || ((argc>2) && (std::string(argv[2]).find("plane") != std::string::npos)) )
        {
            am::Plane plane;
            am::Plane::fromCloud( plane, cloud_ptr, indices_ptr, distanceThreshold );

            std::vector <pcl::PointIndices::Ptr> cluster_ptrs;
            am::Segmentation::region_grow<am::MyPoint>( cluster_ptrs,
                                           plane.CloudPtr(),
                                           plane.IndicesPtr(),
                                           10 );

            am::DepthProcessor::PCA( plane.Frame(), plane.CloudPtr(), plane.IndicesPtr() );
            if ( plane.Frame().block<3,1>(0,2).dot( plane.Normal() ) < 0.f )
            {
                std::cerr << " flipping frame " << std::endl;
                plane.Frame().block<3,1>(0,0) *= -1.f;
                plane.Frame().block<3,1>(0,2) *= -1.f;
            }
            am::Plane::calculateCorners( plane, plane.Frame() );

            std::vector<float> corner_coords(24);
            am::Plane plane2( plane );
            for ( int i = 0; i < plane2.Corners().size(); ++i )
            {
                plane2.Corners()[ i ] = am::util::pcl::asPointXYZ( plane2.Corners()[ i ].getVector3fMap() - plane.Normal() * 1. );
                corner_coords[i*3] = plane.Corners()[i].x;
                corner_coords[i*3+1] = plane.Corners()[i].y;
                corner_coords[i*3+2] = plane.Corners()[i].z;
                corner_coords[(i+4)*3] = plane2.Corners()[i].x;
                corner_coords[(i+4)*3+1] = plane2.Corners()[i].y;
                corner_coords[(i+4)*3+2] = plane2.Corners()[i].z;
            }



            am::Cuboid cuboid;
            am::Cuboid::fromCorners( cuboid, corner_coords, cloud_ptr, indices_ptr );

            auto v_ptr = am::CloudViewer::showCloud( cloud_ptr, "plane", plane.IndicesPtr(), 2., false );
            plane.draw( v_ptr->ViewerPtr(), 1, .2, .0, .0, false, true, true );
            plane2.draw( v_ptr->ViewerPtr(), 2 );
            cuboid.draw( v_ptr->ViewerPtr(), "cloud0" );
            v_ptr->ViewerPtr()->spin();
            return EXIT_SUCCESS;
        }

        // cuboid
        am::Cuboid cuboid;
        {
            am::Cuboid::from_cloud( cuboid,
                                    cloud_ptr,
                                    indices_ptr,
                                    distanceThreshold,
                                    false );
        }

        // show output
        am::CloudViewer cloud_viewer;
        pcl::visualization::PCLVisualizer::Ptr v = cloud_viewer.ViewerPtr();
        {
            // draw plane inliers
            am::PCloud::Ptr roi_cloud_ptr = cuboid.getROICloud();
            cuboid.Planes().colourCloud( roi_cloud_ptr );
            cloud_viewer.addPointCloud( roi_cloud_ptr, "pcloud", nullptr, 5 );

            // config
            cloud_viewer.ViewerPtr()->setCameraClipDistances( .0001, 100. );
            cloud_viewer.ViewerPtr()->setBackgroundColor( .2, .2, .2 );
        }

        for ( int plane_id = 0; plane_id < cuboid.Planes().size(); ++plane_id )
        {
            am::Plane::draw( cuboid.Planes()[plane_id]
                             , v
                             , plane_id
                             , ((plane_id+2) % 3 > 1 ? 2 : 0) * .1
                             , ((plane_id+1) % 3 > 1 ? 2 : 0) * .1
                             , ((plane_id  ) % 3 > 1 ? 2 : 0) * .1
                             , /* drawPlane: */ false );
        }
        am::Cuboid::draw( cuboid, v, "cuboid00" );
        cuboid.writeToFile( cuboid, "coordinates.dat", true );

        // draw cuboid
        v->setRepresentationToSurfaceForAllActors();
        //cuboid.draw( cloud_viewer.ViewerPtr(), "cuboid0" );
        //clamped_cuboid.draw( v, "cuboid1" );

        // spin
        cloud_viewer.ViewerPtr()->spin();
#endif
        return EXIT_SUCCESS;
    }



    // --------------------------------------------

    QApplication a(argc, argv);

    QtCloudViewer qt_cloud_viewer;
    qt_cloud_viewer.show();

    // scripted loading
    {
        // load rgbd
        std::string rgb_path, depth_path;
        if ( ( pcl::console::parse_argument( argc, argv, "--rgb", rgb_path ) > 0 ) &&
             ( pcl::console::parse_argument( argc, argv, "--d", depth_path ) > 0 ) )
        {
            qt_cloud_viewer.getController()->loadNewCloudFromImagePaths( rgb_path, depth_path, 0, 0, 0, 0 );
            //qt_cloud_viewer->getController()->set
        }

        // load cuboids from script
        std::string cuboids_path;
        if ( pcl::console::parse_argument( argc, argv, "--cuboids", cuboids_path ) > 0 )
        {
            qt_cloud_viewer.my_on_loadButton_clicked( cuboids_path );
        }

        // load cloud
        std::string cloud_path;
        if ( pcl::console::parse_argument( argc, argv, "--cloud", cloud_path ) > 0 )
        {
            qt_cloud_viewer.my_on_addPointsButton_clicked( cloud_path );
        }

        std::string walls_path;
        if ( pcl::console::find_switch( argc, argv, "--auto-walls") )
        {
            qt_cloud_viewer.on_loadWallsButton_clicked();
        } else if ( pcl::console::parse_argument( argc, argv, "--walls", walls_path ) > 0 )
        {
            qt_cloud_viewer.loadWalls( walls_path );
        }

        //0.050
        float sphere_size = -1.f;
        if ( pcl::console::parse_argument( argc, argv, "--sphere_size", sphere_size ) > 0 )
        {
            qt_cloud_viewer.on_sphereSizeSlider_valueChanged( sphere_size * 100.f );
        }

        std::string contacts_path;
        if ( pcl::console::parse_argument( argc, argv, "--contacts", contacts_path ) > 0 )
        {
            qt_cloud_viewer.my_on_loadContactsButton_clicked( contacts_path );
        }

        std::string camera_path             = "";
        int         center_camera_arg_id    = 0;
        if ( pcl::console::parse_argument( argc, argv, "--camera", camera_path ) > 0
             || (center_camera_arg_id = pcl::console::parse_argument(argc, argv, "--center-camera", camera_path) ) > 0 )
        {
            qt_cloud_viewer.my_on_loadCameraParamsButton_clicked( camera_path );

            if ( center_camera_arg_id > 0 )
            {
                qt_cloud_viewer.centerCamera();
            }
        }

        std::string screenshot_path;
        if ( pcl::console::parse_argument( argc, argv, "--screenshot", screenshot_path) > 0 )
        {
            qt_cloud_viewer.my_on_screenshotButton_clicked( screenshot_path );
            return EXIT_SUCCESS;
        }
    }

    return a.exec();

    // /home/bontius/workspace/SmartGeometry/Data/SpoonStack.oni
    return EXIT_SUCCESS;
}
