/*
 * =====================================================================================
 *
 *       Filename:  furniture_test.cpp
 *
 *    Description:  Test for furniture suite
 *
 *        Version:  1.0
 *        Created:  10/02/2013 03:56:17 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Moos Hueting (mh), mooshueting@gmail.com
 *   Organization:  
 *
 * =====================================================================================
 */
#include "furniture.h"

int furnituretest_main(int argc, char* argv[]) {
    if (argc < 2) {
        std::cout << "No point cloud specified." << std::endl;
        exit(1);
    }

    FurnitureSuite FS(argv[1]);
    // shrink point cloud into voxel grid (1cm^3)
    FS.decimatePointCloud();
    // remove noise statistically
    // method: http://www.pointclouds.org/documentation/tutorials/statistical_outlier.php
    FS.removeStatisticalNoise();

    // detect walls and ground in point cloud, remove them
    FS.detectPlanes();

    // segment rest into objects
    FS.segment();

    // show separate components
    FS.showPointCloud();
    FS.showClusters();
    FS.showPlanes();

    // finally launch viewer
    FS.showViewer();

    return 0;
}
