#include <iostream>

#include "cuboid_approx/nyu_init/NYUInit.h"


#include <pcl/visualization/pcl_visualizer.h>
#include "primitives/Plane.h"
int
reorderCorners( /*std::vector<pcl::PointXYZ> &corners*/ )
{
    using namespace am;

    std::vector<pcl::PointXYZ> corners = {
        { 3.171185, -0.040297, -3.634009 },
        { 3.171185, -0.040297, -3.281667 },
        { 5.219255, -0.040297, -3.281667 },
        { 5.219255, -0.040297, -3.634009 },
        { 3.171185, 0.610671, -3.634009 },
        { 3.171185, 0.610671, -3.281667 },
        { 5.219255, 0.610671, -3.281667 },
        { 5.219255, 0.610671, -3.634009 }
        };

    pcl::visualization::PCLVisualizer::Ptr vptr( new pcl::visualization::PCLVisualizer() );
    vptr->setBackgroundColor( .5, .5, .7 );
    for  ( int i = 0; i != corners.size(); ++i )
    {
        char tmp[1024];
        sprintf( tmp, "%d", i );
        vptr->addText3D( tmp, corners[i], .1, .2, .0, .0, tmp, 0 );
    }

    Plane plane;
    std::vector<std::vector<int>> corner_ids =
    { {3,0,7,4},
      {0,1,4,5},
      {0,3,1,2},
      {1,2,5,6},
      {2,3,6,7},
      {4,5,7,6},
    };

    for ( int i = 0; i != corner_ids.size(); ++i )
    {
        char tmp[1024];
        sprintf( tmp, "plane%d", i);
        Plane::fromCorners( plane, corners, corner_ids[i], nullptr, nullptr );
        plane.draw( vptr, tmp );
    }

    vptr->spin();

//    // select farthest corners
//    int cid0     = 0,
//        cid1     = 1;
//    float max_dist = 0;
//    for ( int cid = 2 : size( box,1 )
//           dist = distance( box(cid0,:), box(cid,:) );
//           if dist > max_dist
//               max_dist = dist;
//               cid1     = cid;
//           end
//       end
}

int main( int argc, char *argv[] )
{
    using namespace ca;

    if ( pcl::console::find_switch(argc,argv,"--filter") )
        return NYUInit::filterContacts<float,ca::MyPointT>( argc, argv );
    else
        return NYUInit::run<float,ca::MyPointT>( argc, argv );
}
