#include <iostream>

#include <pcl/io/ply_io.h>
#include "pcl/PCLPointCloud2.h"
#include "pcl/visualization/pcl_visualizer.h"

inline pcl::PointXYZRGB
PointXYZRGB( float x, float y, float z, int r = 255, int g = 255, int b = 255 )
{
    pcl::PointXYZRGB pnt;
    pnt.x = x;
    pnt.y = y;
    pnt.z = z;
    pnt.r = r;
    pnt.g = g;
    pnt.b = b;

    return pnt;
}

int main( int argc, char** argv )
{
    std::cout << "hello" << std::endl;
    typedef pcl::PointXYZRGB PointT;

    pcl::PolygonMesh::Ptr mesh( new pcl::PolygonMesh() );
    pcl::PointCloud<PointT>::Ptr cloud( new pcl::PointCloud<PointT>()  );

    cloud->push_back( PointXYZRGB(0,0,0) );
    cloud->push_back( PointXYZRGB(0,1,0) );
    cloud->push_back( PointXYZRGB(1,1,0) );
    cloud->width = 3;
    cloud->height = 1;

    pcl::PCLPointCloud2::Ptr cloud2( new pcl::PCLPointCloud2() );
    pcl::toPCLPointCloud2( *cloud, *cloud2 );

    mesh->cloud = *cloud2;
    //mesh_ptr->polygons[i] = v;
    pcl::Vertices v;
    v.vertices.push_back( 0 );
    v.vertices.push_back( 1 );
    v.vertices.push_back( 2 );
    mesh->polygons.resize(1);
    mesh->polygons[0] = v;

    pcl::visualization::PCLVisualizer::Ptr vptr( new pcl::visualization::PCLVisualizer() );
    vptr->setBackgroundColor( .2, .2, .3 );

    vptr->addPolygonMesh( *mesh, "poly", 0 );

    std::cout << *mesh << std::endl;
    pcl::io::savePLYFile( "mesh.ply", *mesh );
    //vptr->addPointCloud( cloud );

    vptr->spin();

}
