#include "Segmentation.h"

namespace am
{
    // resize normals cloud to match cloud_ptr, copy estimated ones to right positions, leave others as 0
    int
    Segmentation::_expandNormals( pcl::PointCloud<pcl::Normal>::Ptr      &cloud_normals_ptr,
                                  pcl::PointIndices::ConstPtr             in_indices_ptr,
                                  pcl::PointCloud<pcl::Normal>::ConstPtr  roi_cloud_normals_ptr,
                                  int output_size )
    {
        // allocate ptr
        if ( !cloud_normals_ptr ) cloud_normals_ptr = boost::make_shared<pcl::PointCloud<pcl::Normal> >();
        // resize content
        cloud_normals_ptr->resize( output_size );

        // copy non-zeros
        for ( int index_id = 0;
              index_id < in_indices_ptr->indices.size();
              ++index_id )
        {
            try
            {
                cloud_normals_ptr->at( in_indices_ptr->indices[index_id] ) = roi_cloud_normals_ptr->at( index_id );
            } catch ( std::exception ex)
            {
                std::cout << "index_id: " << index_id << std::endl;
                std::cout << "in_indices_ptr->indices[index_id]: " << in_indices_ptr->indices[index_id] << std::endl;
                std::cout << "roi_cloud_normals_ptr->at( index_id ): "<< roi_cloud_normals_ptr->at( index_id ) << std::endl;

                throw ex;
            }
        }
    }
} // ns am
