function process( planes,tit )
    planes{4} = conv(planes{1},ones(1,3)/3);
    planes{5} = conv(planes{2},ones(1,3)/3);
    planes{6} = conv(planes{3},ones(1,3)/3);
    % grads
    for i = 1: 6
        planes{i+6} = gradient( planes{i} );
    end

    colors = 'rgbcmykbgrcmykbgrcmykbgrcmyk';
    figure(); 
    %subplot(211);
    hold on;
    for p = 1 : 3
        plot(planes{p}, [colors(p) '.-']);
    end
    title(tit);
    %plot( conv(plane2,ones(1,3)/3), 'm-');
    
    m0 = max(planes{1});
    m1 = max(planes{2});
    m2 = max(planes{3});
    w = sqrt( m0 * m1 / m2 )
    h = m0/w
    l = m1/w
    t = .2;
    line( [0,length(planes{1})], [(w+h)*t,(w+h)*t], 'Color','r' );
    line( [0,length(planes{1})], [(w+l)*t,(w+l)*t], 'Color','g' );
    line( [0,length(planes{1})], [(h+l)*t,(h+l)*t],'Color','b' );
    legend('along biggest plane''s normal', ...
           'along second biggest plane''s normal', ...
           'along cross product', ...
           sprintf('%2.2f threshold = %f',[t, (w+h)*t]), ...
           sprintf('%2.2f threshold = %f',[t, (w+l)*t]), ...
           sprintf('%2.2f threshold = %f',[t, (h+l)*t]));

    if 0
        %centroids = cell(3);
        colors = 'rgb';
        for i = 1 : 3
            [ labels{i}, centroids{i}] = kmeans( plane{i}, 3 );
            centroids{i};
            for c = 1 : length(centroids{i})
                line( [0,length(plane{1})], [centroids{i}(c),centroids{i}(c)], 'Color', colors(i), 'LineStyle', '--' );
            end
        end
    end
    
    norms{1} = planes{1} / m0 ;
    norms{2} = planes{2} / m1 ;
    norms{3} = planes{3} / m2 ;
    
    figure();
    hold on;
    plot( planes{1} / m0 * 100, 'r' ); title([ tit ' normalized'] );
    plot( planes{2} / m1 * 100, 'g' );
    plot( planes{3} / m2 * 100, 'b' );
    
    for i = 1 : 3
        disp(sprintf('trapz%d: %f', [ i, trapz(norms{i}) ] ));
        disp(sprintf('avg%d: %f', [ i, sum(norms{i})/length(norms{i}) ] ));
        disp(sprintf('std%d: %f', [ i, std(norms{i}) ] ));
        disp(sprintf('var%d: %f', [ i, var(norms{i}) ] ));
        disp(sprintf('max/avg%d: %f', [ i, 1. / mean(norms{i}) ] ));
    end
    
    
    figure();
    hold on;
    for p = 1 : 3
        plot(gradient(planes{p}/m0), [colors(p) '.-']);
        disp(sprintf('avg gradient plane%d: %f', [ p-1, mean(gradient(planes{p}/m0)) ] ));
    end
    title([ tit ' gradient']);
    
    figure();
    hold on;
    for p = 1 : 3
        plot(gradient(gradient(planes{p}/m0)), [colors(p) '.-']);
        disp(sprintf('avg gradient2 plane%d: %f', [ p-1, mean(gradient(gradient(planes{p}/m0))) ] ));
    end
    title([ tit ' gradient2']);
    
    % hyp test
    hyptest( planes, w, h, l, [ tit ' 3plane'] );
    m0
    m1
    m2
    w = (m0+m1)/m2
    h = m0/w
    l = m1/w
    h*l
    
    hyptest( planes, w, h, l, [ tit ' 2plane'] );
    
    
    figure(); hold on;
    colors = 'rgb';
    for i = 1 : 3
        plot( planes{i}, [colors(i) '.-'] );
    end
    for p = 1 : 3
        disp(sprintf('platestart%d',p))
        plates{p} = getPlate( planes{p} );
        line( [0,length(planes{p})], [plates{p},plates{p}], 'Color', colors(p), 'LineStyle', '--' );
    end
    title([ tit ' plate']);
    

    

end

function hyptest( plane, w, h, l, tit )
    fulltit = [ tit ' hyp test' ];
    figure('Name', fulltit ); hold on;
    title( fulltit );
    colors = 'rgb';
    for i = 1 : 3
        plot( plane{i}, [colors(i) '.-'] );
    end
    line( [0,length(plane{1})], [w,w], 'Color', colors(1), 'LineStyle', '--' );
    line( [0,length(plane{1})], [w*h,w*h], 'Color', colors(1), 'LineStyle', ':' );
    
    line( [0,length(plane{2})], [w,w], 'Color', colors(2), 'LineStyle', '--' );
    line( [0,length(plane{2})], [w*l,w*l], 'Color', colors(2), 'LineStyle', ':' );
    
    line( [0,length(plane{2})], [h+l,h+l], 'Color', colors(3), 'LineStyle', '--' );
    %line( [0,length(plane{2})], [h*l,h*l], 'Color', colors(3), 'LineStyle', ':' );
end


% finds next average in right direction
function [b,e,a] = findslope2( in )
    [ mx, b ] = max(in);
    a = median(in);
    len = length(in);
    if ( b > len/2)
        db1 = +1;
        db2 = -1;
    else
        db1 = -1;
        db2 = 1;
    end
    
    while ( (b+db1 > 0) && (b+db1 <= len) && (in(b+db1) > a) )
        b = b+db1;
    end
    if ( (b+db1 > 0) && (b+db1 <= len) && (abs(in(b+db1)-a) < abs(in(b)-a) ) )
        b = b+db1;
    end
    
    e = len;
end

function [b,e,a] = findslope( in )
    [ mx, b ] = max(in);
    a = mean(in);
    len = length(in);
    if ( b > len/2)
        db1 = +1;
        db2 = -1;
    else
        db1 = -1;
        db2 = 1;
    end
    
    while ( b > 0 )
        if (    (b+db1 > 0) ...
             && (abs(in(b+db1)-a) < abs(in(b)-a)) )
            b = b+db1;
        elseif ( (b+db2 <= len) ...
                && (abs(in(b+db2)-a) < abs(in(b)-a)) )
            b = b+db2;
        else
            break;
        end
    end
    e = len;
    
end

function [b,e,a] = findends( in, startb, starte )
    x = in;
    len = length(x);
    
    if ( ~exist('startb','var') )
        startb = 1;
    end
    if ( ~exist('starte','var') )
        starte = length(x);
    end
    
    b = startb;
    while                     (x(b) == 0) ... 
           || ( (b+1<=len) && (x(b+1) > x(b))) ...
           || ( (b-1 >0)   &&  x(b-1) > x(b) )
       if ( (b+1<=len) && (x(b+1) > x(b)))
            b = b+1;
       elseif ( (b-1 >0)   &&  x(b-1) > x(b) )
           b = b-1;
       end
    end
    
    e = length(x);
    while                    ( x(e) == 0 )     ...
          || ( (e-1> 0  ) && (x(e-1) > x(e)) ) ...
          || ( (e+1<=len) && (x(e+1) > x(e)) )
        if ( (e-1> 0  ) && (x(e-1) > x(e)) )
            e = e-1;
        elseif ( (e+1<=len) && (x(e+1) > x(e)) )
            e = e+1;
        end
    end
    disp(sprintf('stopping at x(%d+-1) = %2.2f %2.2f %2.2f', [ e, x(e-1), x(e), x(min(e+1,length(x))) ] ));
    
    a = mean(x);
end